package com.andrious.simplecalculator

import android.content.res.Configuration
import android.graphics.Color
import android.os.Bundle
import android.util.TypedValue
import android.view.View
import android.widget.Button
import android.widget.ImageButton
import android.widget.TextView
import androidx.appcompat.app.AppCompatActivity
import kotlinx.android.synthetic.main.activity_main.*

class MainActivity : AppCompatActivity() {
    var result_value: Double = 0.0
    var checker:Boolean = true
    var orientation = 0

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        var button_0  = findViewById(R.id.button_0) as Button
        var button_1  = findViewById(R.id.button_1) as Button
        var button_2  = findViewById(R.id.button_2) as Button
        var button_3  = findViewById(R.id.button_3) as Button
        var button_4  = findViewById(R.id.button_4) as Button
        var button_5  = findViewById(R.id.button_5) as Button
        var button_6  = findViewById(R.id.button_6) as Button
        var button_7  = findViewById(R.id.button_7) as Button
        var button_8  = findViewById(R.id.button_8) as Button
        var button_9  = findViewById(R.id.button_9) as Button
        var button_add  = findViewById(R.id.button_add) as Button
        var button_sub  = findViewById(R.id.button_sub) as Button
        var button_multi  = findViewById(R.id.button_multi) as Button
        var button_div  = findViewById(R.id.button_div) as Button
        var button_modulas  = findViewById(R.id.button_modulas) as Button
        var button_dot  = findViewById(R.id.button_dot) as Button
        var button_equal  = findViewById(R.id.button_equal) as Button
        var button_clear  = findViewById(R.id.button_clear) as Button
        var button_back  = findViewById(R.id.button_back) as ImageButton
        var result  = findViewById(R.id.result) as TextView
        var display  = findViewById(R.id.display) as TextView

        orientation = resources.configuration.orientation
        button_modulas.isEnabled = false
        entry_controller(checker)

        button_0.setOnClickListener(View.OnClickListener {
            display.text = display.text.toString() + "0"
            text_size_color_controller();
            checker = false
            entry_controller(checker)
        })
        button_1.setOnClickListener(View.OnClickListener {
            display.text = display.text.toString() + "1"
            text_size_color_controller();
            checker = false
            entry_controller(checker)
        })
        button_2.setOnClickListener(View.OnClickListener {
            display.text = display.text.toString() + "2"
            text_size_color_controller();
            checker = false
            entry_controller(checker)
        })
        button_3.setOnClickListener(View.OnClickListener {
            display.text = display.text.toString() + "3"
            text_size_color_controller();
            checker = false
            entry_controller(checker)
        })
        button_4.setOnClickListener(View.OnClickListener {
            display.text = display.text.toString() + "4"
            text_size_color_controller();
            checker = false
            entry_controller(checker)
        })
        button_5.setOnClickListener(View.OnClickListener {
            display.text = display.text.toString() + "5"
            text_size_color_controller()
            checker = false
            entry_controller(checker)
        })
        button_6.setOnClickListener(View.OnClickListener {
            display.text = display.text.toString() + "6"
            text_size_color_controller()
            checker = false
            entry_controller(checker)
        })
        button_7.setOnClickListener(View.OnClickListener {
            display.text = display.text.toString() + "7"
            text_size_color_controller()
            checker = false
            entry_controller(checker)
        })
        button_8.setOnClickListener(View.OnClickListener {
            display.text = display.text.toString() + "8"
            text_size_color_controller()
            checker = false
            entry_controller(checker)
        })
        button_9.setOnClickListener(View.OnClickListener {
            display.text = display.text.toString() + "9"
            text_size_color_controller()
            checker = false
            entry_controller(checker)
        })
        button_dot.setOnClickListener(View.OnClickListener {
            display.text = display.text.toString() + "."
            text_size_color_controller()
            checker = false
            entry_controller(checker)
        })
        button_add.setOnClickListener(View.OnClickListener {
            display.text = display.text.toString() + "+"
            text_size_color_controller()
            checker = true
            entry_controller(checker)
        })
        button_sub.setOnClickListener(View.OnClickListener {
            display.text = display.text.toString() + "-"
            text_size_color_controller()
            checker = true
            entry_controller(checker)
        })
        button_multi.setOnClickListener(View.OnClickListener {
            display.text = display.text.toString() + "*"
            text_size_color_controller()
            checker = true
            entry_controller(checker)
        })
        button_div.setOnClickListener(View.OnClickListener {
            display.text = display.text.toString() + "/"
            text_size_color_controller()
            checker = true
            entry_controller(checker)
        })
        button_modulas.setOnClickListener(View.OnClickListener {

            result.text = "=" + (result_value/100.0).toString()
        })
        button_clear.setOnClickListener(View.OnClickListener {
            display.text = ""
            result.text = ""
            result.visibility = View.GONE
            display.setTextSize(TypedValue.COMPLEX_UNIT_DIP,36F)
        })
        button_back.setOnClickListener(View.OnClickListener {
            var data = display.text.toString()
            if(data.length > 0){
                display.text = data.substring(0, data.length - 1)
                text_size_color_controller();
            }
        })
        button_equal.setOnClickListener(View.OnClickListener {
            var data = display.text.toString()
            if(!data.endsWith("+") || !data.endsWith("-") || !data.endsWith("*") || !data.endsWith("/")){
                result_value = calculation(data)
                result.visibility = View.VISIBLE
                result.text = "= " + String.format("%.5f", result_value).toDouble().toString()
                display.setTextColor(Color.parseColor("#bdbdbd"))
                result.setTextColor(Color.parseColor("#000000"))
                if (orientation == Configuration.ORIENTATION_LANDSCAPE) {
                    // In landscape
                    display.setTextSize(TypedValue.COMPLEX_UNIT_DIP,26F)
                    result.setTextSize(TypedValue.COMPLEX_UNIT_DIP,20F)
                } else {
                    // In portrait
                    display.setTextSize(TypedValue.COMPLEX_UNIT_DIP,26F)
                    result.setTextSize(TypedValue.COMPLEX_UNIT_DIP,36F)
                }
                button_modulas.isEnabled = true
            }
        })
    }
    fun text_size_color_controller(): Void? {
        display.setTextColor(Color.parseColor("#000000"))
        result.setTextColor(Color.parseColor("#bdbdbd"))
        if (orientation == Configuration.ORIENTATION_LANDSCAPE) {
            // In landscape
            display.setTextSize(TypedValue.COMPLEX_UNIT_DIP,30F)
            result.setTextSize(TypedValue.COMPLEX_UNIT_DIP,20F)
        } else {
            // In portrait
            display.setTextSize(TypedValue.COMPLEX_UNIT_DIP,36F)
            result.setTextSize(TypedValue.COMPLEX_UNIT_DIP,26F)
        }
        button_modulas.isEnabled = false

        return null
    }

    fun entry_controller(b:Boolean): Void? {
        if(b){
            button_add.isEnabled = false
            button_sub.isEnabled = false
            button_multi.isEnabled = false
            button_div.isEnabled = false
            button_equal.isEnabled = false
        }else{
            button_add.isEnabled = true
            button_sub.isEnabled = true
            button_multi.isEnabled = true
            button_div.isEnabled = true
            button_equal.isEnabled = true
        }
        return null
    }
    fun calculation(str: String): Double {
        return object : Any() {
            var pos = -1
            var ch = 0
            fun nextChar() {
                if(++pos < str.length){
                    ch = str[pos].toInt()
                }else{
                    ch = -1
                }
            }
            fun eat(charToEat: Int): Boolean {
                while (ch == ' '.toInt()) nextChar()
                if (ch == charToEat) {
                    nextChar()
                    return true
                }
                return false
            }
            fun parse(): Double {
                nextChar()
                val x = parseExpression()
                if (pos < str.length) throw RuntimeException("Unexpected: " + ch.toChar())
                return x
            }

            // Grammar:
            // expression = term | expression `+` term | expression `-` term
            // term = factor | term `*` factor | term `/` factor
            // factor = `+` factor | `-` factor | `(` expression `)`
            //        | number | functionName factor | factor `^` factor
            fun parseExpression(): Double {
                var x = parseTerm()
                while (true) {
                    if (eat('+'.toInt())) x += parseTerm() // addition
                    else if (eat('-'.toInt())) x -= parseTerm() // subtraction
                    else return x
                }
            }

            fun parseTerm(): Double {
                var x = parseFactor()
                while (true) {
                    if (eat('*'.toInt())) x *= parseFactor() // multiplication
                    else if (eat('/'.toInt())) x /= parseFactor() // division
                    else return x
                }
            }

            fun parseFactor(): Double {
                if (eat('+'.toInt())) return parseFactor() // unary plus
                if (eat('-'.toInt())) return -parseFactor() // unary minus
                var x: Double
                val startPos = pos
                if (eat('('.toInt())) { // parentheses
                    x = parseExpression()
                    eat(')'.toInt())
                } else if (ch >= '0'.toInt() && ch <= '9'.toInt() || ch == '.'.toInt()) { // numbers
                    while (ch >= '0'.toInt() && ch <= '9'.toInt() || ch == '.'.toInt()) nextChar()
                    x = str.substring(startPos, pos).toDouble()
                } else if (ch >= 'a'.toInt() && ch <= 'z'.toInt()) { // functions
                    while (ch >= 'a'.toInt() && ch <= 'z'.toInt()) nextChar()
                    val func = str.substring(startPos, pos)
                    x = parseFactor()
                    x =
                        if (func == "sqrt") Math.sqrt(x) else if (func == "sin") Math.sin(
                            Math.toRadians(
                                x
                            )
                        ) else if (func == "cos") Math.cos(Math.toRadians(x)) else if (func == "tan") Math.tan(
                            Math.toRadians(x)
                        ) else throw RuntimeException(
                            "Unknown function: $func"
                        )
                } else {
                    throw RuntimeException("Unexpected: " + ch.toChar())
                }
                if (eat('^'.toInt())) x = Math.pow(x, parseFactor()) // exponentiation
                return x
            }
        }.parse()
    }
}
